<?php
/**
* @package     plg_juvirtualdomain
* @author      Denys Nosov, Denis Ryabov
* @copyright   2008-2012 (c) Denys Nosov,  Joomla! Ukraine (http://joomla-ua.org). All rights reserved.
* @copyright   2007 (c) Denis Ryabov. All rights reserved.
* @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @version     JUVirtualDomain 5.0
**/

defined('_JEXEC') or die;

//jimport('joomla.plugin.plugin');
jimport('joomla.environment.response');

class plgSystemJUVirtualDomain extends JPlugin
{

	public function plgSystemJUVirtualDomain(&$subject,$config)
	{
		parent::__construct($subject,$config); 
	}

    public function onAfterRender()
    {
        $app = JFactory::getApplication();

        if ($app->getName() != 'site') {
        	return true;
        }

		$data   = $this->params->get( 'domainlangtemplate' );
		$lines  = explode( "\n", $data );

		foreach($lines as $line) if(trim($line))
		{
			$domain = $lang = $template = null;
			list( $domain, $lang, $template ) = explode( '|', trim($line) );
			if( ($domain==$_SERVER['HTTP_HOST']) && ($template) )
			{
			    if($this->params->get( 'allowcache' ) == 1)
                {
                    JResponse::allowCache(true);
                    if($this->params->get( 'pragma' ) == 1) {
                        JResponse::setHeader('Pragma', 'public', true);
                    }
                    if($this->params->get( 'cachecontrol' ) == 1) {
                        JResponse::setHeader('Cache-Control', 'public', true);
                    }
                    if($this->params->get( 'expires' ) == 1) {
                        JResponse::setHeader('Expires', gmdate('D, d M Y H:i:s', time()+$this->params->get( 'expirestime' )) . ' GMT', true);
                    }
			    }
                break;
            }
        }
    }

	public function onAfterInitialise()
	{
        $app = JFactory::getApplication();

        if ($app->getName() != 'site') {
        	return true;
        }

		$data   = $this->params->get( 'domainlangtemplate' );
		$lines  = explode( "\n", $data );

        $parsed = parse_url(JURI::base());
        $path   = isset($parsed['path']) ? $parsed['path'] : '';

		foreach($lines as $line) if(trim($line))
		{
			$domain = $lang = $template = $homepage = null;
			list( $domain, $lang, $template, $homepage ) = explode( '|', trim($line) );

			if( $domain==$_SERVER['HTTP_HOST'] )
			{
				$config     = & JFactory::getConfig();
				$language   = & JFactory::getLanguage();

                if(!$lang) {
                    $lang = $config->getValue('config.language');
                }

				$config->setValue( 'config.language', $lang );
                $config->setValue( 'config.caching', false );
				$language->setLanguage( $lang );

                if ($template)
                {
				    $app->setTemplate( $template );
                }

                if ($homepage)
                {
        			if( $_SERVER['REQUEST_URI'] == $path || $_SERVER['REQUEST_URI']== $path .'index.php' )
        			{
                        $_SERVER['REQUEST_URI'] = $path . $homepage;

                        if(substr($homepage,0,10)=='index.php?')
                        {
                            $_SERVER['QUERY_STRING']=substr($homepage,10);
                            parse_str($_SERVER['QUERY_STRING'],$_REQUEST);
                            $_GET=$_REQUEST;
                            $_REQUEST+=$_COOKIE;
                            $GLOBALS['_JREQUEST']=array(); // reset JRequest cache
                        }
        			}
    			}

				break;
			}
		}
	}
}